package sun.security.krb5.internal;

import java.math.BigInteger;
import sun.security.util.DerOutputStream;
import java.io.IOException;
import sun.security.krb5.Asn1Exception;
import sun.security.util.DerValue;

public class MethodData
{
    private int methodType;
    private byte[] methodData;
    
    public MethodData(int methodType, byte[] array) {
        this.methodData = null;
        this.methodType = methodType;
        if (array != null) {
            this.methodData = (byte[])array.clone();
        }
    }
    
    public MethodData(DerValue derValue) throws Asn1Exception, IOException {
        this.methodData = null;
        if (derValue.getTag() != 48) {
            throw new Asn1Exception(906);
        }
        DerValue derValue2 = derValue.getData().getDerValue();
        if ((derValue2.getTag() & 0x1F) == 0x0) {
            this.methodType = derValue2.getData().getBigInteger().intValue();
            if (derValue.getData().available() > 0) {
                DerValue derValue3 = derValue.getData().getDerValue();
                if ((derValue3.getTag() & 0x1F) == 0x1) {
                    this.methodData = derValue3.getData().getOctetString();
                }
                else {
                    throw new Asn1Exception(906);
                }
            }
            if (derValue.getData().available() > 0) {
                throw new Asn1Exception(906);
            }
            return;
        }
        else {
            throw new Asn1Exception(906);
        }
    }
    
    public byte[] asn1Encode() throws Asn1Exception, IOException {
        DerOutputStream derOutputStream = new DerOutputStream();
        DerOutputStream derOutputStream2 = new DerOutputStream();
        derOutputStream2.putInteger(BigInteger.valueOf((long)this.methodType));
        derOutputStream.write(DerValue.createTag((byte)(-128), true, (byte)0), derOutputStream2);
        if (this.methodData != null) {
            DerOutputStream derOutputStream3 = new DerOutputStream();
            derOutputStream3.putOctetString(this.methodData);
            derOutputStream.write(DerValue.createTag((byte)(-128), true, (byte)1), derOutputStream3);
        }
        DerOutputStream o = new DerOutputStream();
        o.write((byte)48, derOutputStream);
        return o.toByteArray();
    }
}
